<div class="wrap newsletters <?php echo $this -> pre; ?> <?php echo $this -> sections -> queue; ?>">
	<h1>
		<?php _e('Email Queue', $this -> plugin_name); ?> 
		<a href="?page=<?php echo $this -> sections -> queue; ?>" class="add-new-h2"><?php _e('Refresh', $this -> plugin_name); ?></a>
	</h1>
	
	<?php
		
	$queue_status = $this -> get_option('queue_status');
	delete_transient('newsletters_queue_count');
	$count = $this -> queue_process -> get_queued_count();
	echo '<p>' . sprintf(__('There are currently %s emails in the queue.', $this -> plugin_name), '<b>' . $count . '</b>') . '</p>';	
	
	$errors = $this -> queue_process -> get_batches(false, true);
		
	?>
	
	<div class="actions">
		<?php if (empty($queue_status) || $queue_status == "unpause") : ?>
			<a id="newsletters_pause_queue_button" href="" onclick="newsletters_pause_queue('pause'); return false;" class="button"><i id="pausequeueicon" class="fa fa-pause"></i> <?php _e('Pause', $this -> plugin_name); ?></a>
		<?php else : ?>
			<a id="newsletters_pause_queue_button" href="" onclick="newsletters_pause_queue('unpause'); return false;" class="button"><i class="fa fa-play"></i> <?php _e('Unpause', $this -> plugin_name); ?></a>
		<?php endif; ?>
		<?php if (!empty($count)) : ?>
			<a href="?page=<?php echo $this -> sections -> queue; ?>&amp;method=clear" onclick="if (!confirm('<?php _e('Are you sure you wish to purge the email queue?', $this -> plugin_name); ?>')) { return false; }" class="button"><i class="fa fa-trash"></i> <?php _e('Clear Queue', $this -> plugin_name); ?></a>
			<a href="<?php echo admin_url('admin.php?page=' . $this -> sections -> settings_tasks . '&method=runschedule&hook=wp_queue_process_cron'); ?>" onclick="if (!confirm('<?php _e('Are you sure you want to run the queue schedule now and send out emails?', $this -> plugin_name); ?>')) { return false; }" class="button"><i class="fa fa-send"></i> <?php _e('Run Now', $this -> plugin_name); ?></a>
		<?php endif; ?>
	</div>
	
	<?php if (!empty($count)) : ?>
		<p><?php echo $Html -> next_scheduled('wp_queue_process_cron'); ?></p>
	<?php endif; ?>
	
	<script type="text/javascript">
		function newsletters_pause_queue(status) {
			
			jQuery('#newsletters_pause_queue_button').attr('disabled', "disabled").find('i').attr('class', "fa fa-refresh fa-spin");
			
			jQuery.ajax({
				url: newsletters_ajaxurl + 'action=newsletters_pause_queue',
				data: {status:status},
				cache: false,
				type: "POST",
				success: function(response) {					
					if (response == false) {
						alert('<?php _e('Queue could not be paused, please try again', $this -> plugin_name); ?>');
					} else {
						if (status == "unpause") {
							var pause_queue_html = '<i class="fa fa-pause"></i> <?php echo __('Pause', $this -> plugin_name); ?>';
							var pause_queue_action = 'pause';
						} else {
							var pause_queue_html = '<i class="fa fa-play"></i> <?php echo __('Unpause', $this -> plugin_name); ?>';
							var pause_queue_action = 'unpause';
						}
						
						jQuery('#newsletters_pause_queue_button').removeAttr('disabled').html(pause_queue_html).attr('onclick', "newsletters_pause_queue('" + pause_queue_action + "'); return false;");		
					}
				}
			});
		}
	</script>
	
	<?php if (!empty($errors)) : ?>
		<br class="clear" />
		<h2><?php _e('Queue Errors', $this -> plugin_name); ?></h2>
		<p><?php echo __('The emails below are still in the queue with errors and will be retried.', $this -> plugin_name); ?></p>
		<table class="widefat">
			<thead>
				<tr>
					<td><?php _e('Subscriber/User', $this -> plugin_name); ?></td>
					<td><?php _e('Newsletter', $this -> plugin_name); ?></td>
					<td><?php _e('Error', $this -> plugin_name); ?></td>
				</tr>
			</thead>
			<tfoot>
				<tr>
					<td><?php _e('Subscriber/User', $this -> plugin_name); ?></td>
					<td><?php _e('Newsletter', $this -> plugin_name); ?></td>
					<td><?php _e('Error', $this -> plugin_name); ?></td>
				</tr>
			</tfoot>
			<tbody>
				<?php foreach ($errors as $error) : ?>
					<?php foreach ($error -> data as $data) : ?>
						<tr class="<?php echo $class = (empty($class)) ? 'alternate' : ''; ?>">
							<td>
								<?php
									
								if (!empty($data['subscriber_id'])) {
									$subscriber = $Subscriber -> get($data['subscriber_id']); 
								} elseif (!empty($data['user_id'])) {
									$user = $this -> userdata($data['user_id']);
								}	
									
								?>
								<?php if (!empty($subscriber)) : ?>
									<a href="?page=<?php echo $this -> sections -> subscribers; ?>&amp;method=view&amp;id=<?php echo $subscriber -> id; ?>" class="row-title" title="<?php _e('View this subscriber', $this -> plugin_name); ?>"><?php echo $subscriber -> email; ?></a>
								<?php elseif (!empty($user)) : ?>
									<a href="<?php echo get_edit_user_link($user -> ID); ?>" class="row-title"><?php echo $user -> display_name; ?></a>
									<br/><small><?php echo $user -> user_email; ?></small>
								<?php endif; ?>
							</td>
							<td><?php echo $Html -> link(__($data['subject']), "?page=" . $this -> sections -> history . "&amp;method=view&amp;id=" . $data['history_id']); ?></td>
		                    <td>
		                    	<?php echo $data['error']; ?>
		                    </td>
						</tr>
					<?php endforeach; ?>
				<?php endforeach; ?>
			</tbody>
		</table>
	<?php endif; ?>
	
	<?php /*<table class="widefat">
		<tbody>
			<?php if ($batches = $this -> queue_process -> get_batches()) : ?>
				<?php foreach ($batches as $batch) : ?>
					<tr>
						<th><input type="checkbox" /></th>
						<td>
							<?php echo $batch -> key; ?>
						</td>
					</tr>
				<?php endforeach; ?>
			<?php else : ?>
				<tr class="no-items">
					<td class="colspanchange" colspan="<?php echo $colspan; ?>"><?php _e('No queued emails found', $this -> plugin_name); ?></td>
				</tr>
			<?php endif; ?>
		</tbody>
	</table>*/ ?>
	
	<?php /*<h3><?php _e('Schedule Details', $this -> plugin_name); ?></h3>
	
	<div class="postbox" style="padding:10px;">
		<table class="widefat queuetable">
			<tbody>
				<tr class="alternate">
					<th><?php _e('Total emails in queue', $this -> plugin_name); ?></th>
					<td><?php echo $Queue -> count(); ?> <?php _e('emails', $this -> plugin_name); ?></td>
				</tr>
				<tr>
					<th><?php _e('Current Date &amp; Time', $this -> plugin_name); ?></th>
					<td><?php echo $Html -> gen_date(); ?></td>
				</tr>
				<tr class="alternate">
					<th>
						<?php _e('Next schedule event', $this -> plugin_name); ?>
						<?php echo $Html -> link(__('Run Now', $this -> plugin_name), '?page=' . $this -> sections -> settings_tasks . '&method=runschedule&hook=cronhook', array('class' => "button button-secondary button-small", 'onclick' => "if (!confirm('" . __('Are you sure you want to execute this task right now?', $this -> plugin_name) . "')) { return false; }")); ?>
					</th>
					<td>
                    	<?php if ($this -> get_option('schedulecrontype') == "wp") : ?>
							<?php $nextschedule = wp_next_scheduled('wpml_cronhook'); ?>
                            <?php if (!empty($nextschedule)) : ?>	                                
                                <div id="countdown"></div>
                            
	                            <script type="text/javascript">
								jQuery(document).ready(function() {
									jQuery('#countdown').countdown({
										format:'HMS',
										until:'+<?php echo (wp_next_scheduled('wpml_cronhook') - time()); ?>',
										onExpiry:function() { window.location = "<?php echo '?page=' . $this -> sections -> settings_tasks . '&method=runschedule&hook=cronhook'; ?>"; },
									});
								});
								</script>								
                            <?php else : ?>
                                <?php echo __('No interval has been set yet. Please do that in the configuration.', $this -> plugin_name); ?>
                            <?php endif; ?>
                        <?php else : ?>
                        	<?php _e('Server cron is being used.', $this -> plugin_name); ?>
                        <?php endif; ?>
					</td>
				</tr>
				<tr>
					<th><?php _e('Schedule Interval', $this -> plugin_name); ?></th>
					<td>
	                	<?php if ($this -> get_option('schedulecrontype') == "wp") : ?>
							<?php echo $Html -> next_scheduled('cronhook'); ?>
	                    <?php else : ?>
	                    	<?php _e('Server cron is being used.', $this -> plugin_name); ?>
	                    <?php endif; ?>
	                </td>
				</tr>
				<tr class="alternate">
					<th><?php _e('Emails per schedule interval', $this -> plugin_name); ?></th>
					<td><?php echo $this -> get_option('emailsperinterval'); ?> <?php _e('emails', $this -> plugin_name); ?></td>
				</tr>
			</tbody>
		</table>
	</div>
	
	<h3 id="current-queue-emails"><?php _e('Current Queue Emails', $this -> plugin_name); ?></h3>
	<?php if (!empty($queues)) : ?>
		<form id="posts-filter" method="post" action="?page=<?php echo $this -> sections -> queue; ?>">
			<?php if (!empty($queues)) : ?>
				<ul class="subsubsub">
					<li><?php echo (empty($_GET['showall'])) ? $paginate -> allcount : count($queues); ?> <?php _e('queued emails', $this -> plugin_name); ?> |</li>
					<?php if (empty($_GET['showall'])) : ?>
						<li><?php echo $Html -> link(__('Show All', $this -> plugin_name), $this -> url . '&amp;showall=1'); ?> |</li>
					<?php else : ?>
						<li><?php echo $Html -> link(__('Show Paging', $this -> plugin_name), "?page=" . $this -> sections -> queue); ?> |</li>
					<?php endif; ?>
					<?php if ((isset($_COOKIE[$this -> pre . 'queuessorting']) && $_COOKIE[$this -> pre . 'queuessorting'] == "modified") || (!isset($_COOKIE[$this -> pre . 'queuessubjectdir']) || $_COOKIE[$this -> pre . 'queuessubjectdir'] == "DESC")) : ?>
						<li><?php echo $Html -> link(__('A to Z', $this -> plugin_name), '#void', array('onclick' => "change_sorting('subject', 'ASC');")); ?> |</li>
					<?php else : ?>
						<li><?php echo $Html -> link(__('Z to A', $this -> plugin_name), '#void', array('onclick' => "change_sorting('subject', 'DESC');")); ?> |</li>
					<?php endif; ?>
					<?php if ((isset($_COOKIE[$this -> pre . 'queuessorting']) && $_COOKIE[$this -> pre . 'queuessorting'] == "subject") || (!isset($_COOKIE[$this -> pre . 'queuesmodifieddir']) || $_COOKIE[$this -> pre . 'queuesmodifieddir'] == "ASC")) : ?>
						<li><?php echo $Html -> link(__('New to Old', $this -> plugin_name), '#void', array('onclick' => "change_sorting('modified', 'DESC');")); ?></li>
					<?php else : ?>
						<li><?php echo $Html -> link(__('Old to New', $this -> plugin_name), '#void', array('onclick' => "change_sorting('modified', 'ASC');")); ?></li>
					<?php endif; ?>
				</ul>
			<?php endif; ?>
		</form>
		<br class="clear" />
	<?php endif; ?>
	<form id="posts-filter" action="?page=<?php echo $this -> sections -> queue; ?>" method="get">
    	<input type="hidden" name="page" value="<?php echo $this -> sections -> queue; ?>">
    	    	
    	<div class="alignleft actions">
    		<?php _e('Filters:', $this -> plugin_name); ?>
    		<select style="max-width:200px;" name="history_id">
    			<option value=""><?php _e('All History Emails', $this -> plugin_name); ?></option>
    			<?php if ($histories = $this -> History() -> select(10)) : ?>
    				<?php foreach ($histories as $history_id => $history_subject) : ?>
    					<option <?php echo (!empty($_GET['history_id']) && $_GET['history_id'] == $history_id) ? 'selected="selected"' : ''; ?> value="<?php echo $history_id; ?>"><?php echo $history_subject; ?></option>
    				<?php endforeach; ?>
    			<?php endif; ?>
    		</select>
    		<select name="theme_id">
    			<option value=""><?php _e('All Templates', $this -> plugin_name); ?></option>
    			<?php if ($themes = $Theme -> select()) : ?>
    				<?php foreach ($themes as $theme_id => $theme_title) : ?>
    					<option <?php echo (!empty($_GET['theme_id']) && $_GET['theme_id'] == $theme_id) ? 'selected="selected"' : ''; ?> value="<?php echo $theme_id; ?>"><?php echo $theme_title; ?></option>
    				<?php endforeach; ?>
    			<?php endif; ?>
    		</select>
    		<input type="submit" name="filter" value="<?php _e('Filter', $this -> plugin_name); ?>" class="button button-primary">
    	</div>
    </form>
    <br class="clear" />
	<?php $this -> render('queues' . DS . 'loop', array('queues' => $queues, 'paginate' => $paginate), true, 'admin'); ?>*/ ?>
</div>